from v6d2ctx.context import Context
from v6d3music.core.real_url import real_url
from v6d3music.core.ytaservicing import YTAServicing
from v6d3music.core.ytaudio import YTAudio
from v6d3music.utils.argctx import BoundCtx, InfoCtx

__all__ = ("create_ytaudio",)


async def _create_ytaudio(servicing: YTAServicing, bound: BoundCtx) -> YTAudio:
    return YTAudio(
        servicing,
        await real_url(bound.url, False),
        bound.url,
        bound.description,
        bound.options,
        bound.member,
        bound.already_read,
    )


async def create_ytaudio(servicing: YTAServicing, ctx: Context, it: InfoCtx) -> YTAudio:
    bound = it.bind(ctx)
    return await _create_ytaudio(servicing, bound)
